
do
	local super=XPRACTICE.Scenario
	XPRACTICE.RYGELONARENA.Scenario=XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.RYGELONARENA.Scenario
	
	XPRACTICE.RYGELONARENA.NPCID=182777
	

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		self.savedataname="RYGELONARENA"
		self.npcid=XPRACTICE.RYGELONARENA.NPCID

		self.phaseinprogress=false
		self.currentphase=1
		self.phasecomplete=false

		self.player=nil
		self.startbutton=nil
		self.lastmovetime=0
		
		self.events={}
		self.stopallevents=false
		
		self.allplayers={}	--TODO: get rid of this -- we get it confused with multiplayer.allplayers
			
		self.circles={}

		self.reportedcollisionlist={}
		
		self.bossqueue={}
		self.bossgcd=0
		self.inphasecount=0
		
		self.totaldeaths=0
		self.timeelapsed=0
		self.lastreportedtime=0
		self.reportedtimeup=false
		
		self.resultstimer=nil
		self.endtimer=nil
		
		self.debufftracker=nil
		
		self.queueloader=nil
	end
	


	function class:Populate()
		super.Populate(self)
		
		local scenario=self
		
		self.phaseinprogress=false
		self.phasetime=0
		
		self.buttongroup={}
		self.buttongroup[1]={}		-- Options/Go

		
		self.markers={}
		
	
		local scenario=self
		local gamemenu=XPRACTICE.GameMenu.new()
		gamemenu:Setup(self.game.environment_gameplay,self.game.SCREEN_WIDTH/2-180/2,self.game.SCREEN_HEIGHT/2-270/2)
		self.gamemenu=gamemenu
		

		self.game.environment_gameplay.modelsceneframe:SetLightDirection(.2,0,-1)
		self.game.environment_gameplay.modelsceneframe:SetCameraFarClip(400)

		self.collision=XPRACTICE.RYGELONARENA.Collision.new()
		self.collision.scenario=self
		
		local button

		
		local label=XPRACTICE.FadingLabel.new()		
		label:Setup(self.game.environment_gameplay)
		label.position={x=self.game.SCREEN_WIDTH/2-600/2,y=150,z=0}
		label:SetSize(600,300)
		label:SetText("")
		self.statuslabel=label

		self.debugbuttonx=self.game.SCREEN_WIDTH/2-25
		self.debugbuttony=104
				

		local label=XPRACTICE.LeftAlignedLabel.new()		
		label:Setup(self.game.environment_gameplay)
		label.position={x=self.game.SCREEN_WIDTH-200,y=20,z=0}
		label:SetSize(200,100)
		label:SetText("")
		self.populationlabel=label


		local mob,obj
		local player


		
		--mob=XPRACTICE.Mob.new()
		player=XPRACTICE.PlayerCharacter.new()		
		player:Setup(self.game.environment_gameplay)
		player.displayobject.drawable:SetSheathed(false) 
		
		--player.position={x=-15,y=0,z=0}
		player.position={x=0,y=0,z=0}
		player.orientation.yaw=math.pi/6;player.orientation_displayed.yaw=player.orientation.yaw

		player.scenario=self
		self.player=player		
		tinsert(self.allplayers,player)

		

		self.game.environment_gameplay.cameramanager.camera.focus=player
		self.game.environment_gameplay.cameramanager.camera.orientation.yaw=player.orientation.yaw
		--self.game.environment_gameplay.cameramanager.camera.orientation.pitch=math.pi*0.05
		self.game.environment_gameplay.cameramanager.camera.orientation.pitch=math.pi*0.15
		--self.game.environment_gameplay.cameramanager.camera.cdist=30
		self.game.environment_gameplay.cameramanager.camera.cdist=45
		
		
		local lossofcontrolalert=XPRACTICE.LossOfControlAlert.new()
		self.lossofcontrolalert=lossofcontrolalert
		lossofcontrolalert:Setup(self.game.environment_gameplay)
		lossofcontrolalert.position={x=self.game.SCREEN_WIDTH/2-180/2,y=self.game.SCREEN_HEIGHT/2,z=0}
		lossofcontrolalert.focus=player

		
		--TODO LATER: move elsewhere
		local maincastingbar=XPRACTICE.CastingBar.new()
		self.maincastingbar=maincastingbar
		maincastingbar:Setup(self.game.environment_gameplay)
		maincastingbar.position={x=self.game.SCREEN_WIDTH/2-196/2,y=150,z=0}
		maincastingbar.focus=player
		
		local controller=XPRACTICE.PlayerController.new()
		controller:Setup(self.game.environment_gameplay,player,self.game.environment_gameplay.cameramanager.camera)
		
			
		
		
		self.multiplayer=XPRACTICE.RYGELONARENA.Multiplayer.new()
		self.multiplayer.murlocscopyplayerappearances=true
		self.multiplayer:Setup(self.npcid,self,self.game.environment_gameplay)	
		self.multiplayer:SendHello()
		
		
		
		
		self.boss=XPRACTICE.RYGELONARENA.Rygelon.new()
		self.boss.scenario=self
		self.boss:Setup(self.game.environment_gameplay)
		self.boss.position={x=31,y=18,z=0}				
		self.boss:FreezeOrientation(math.pi+math.pi/6)
		local nameplate=XPRACTICE.Nameplate.new()
		nameplate.hp_TEMP=0.75
		nameplate:Setup(self.game.environment_gameplay,self.boss)
		nameplate:SetText("Rygelon")
		local castingbar=XPRACTICE.CastingBarTiny.new()
		castingbar:Setup(self.game.environment_gameplay,0,0,0)
		castingbar.focus=self.boss
		castingbar:AnchorToNameplate(nameplate)
		local mobclickzone=XPRACTICE.MobClickZone.new()
		mobclickzone:Setup(self.game.environment_gameplay,self.boss)
		
		self.tempmenu=XPRACTICE.TempMenuInterfaceCollection.new()
		self.tempmenu.scenario=self
		self.tempmenu:Setup(self.game.environment_gameplay)		


		-- we use a separate mob for hidden spells so we can cast while boss is already casting
			-- pick a mob class at random.  we can't use Mob because the game doesn't know how to handle FileID(1) after rebooting
				-- (function crashes silently, no lua error!)
		local obj=XPRACTICE.INDIGNATION.CrimsonCabalist.new()
		obj:Setup(self.game.environment_gameplay)
		obj.alpha=0		-- invisible bunny
		obj.scenario=self
		self.spellbunny=obj
		

		
		-- self.layout=XPRACTICE.RYGELONARENA.Layout.new()
		-- self.layout:Setup(self.game.environment_gameplay,self)
		
		local floorobj
		floorobj=XPRACTICE.RYGELONARENA.Floor.new()
		floorobj:Setup(self.game.environment_gameplay)
		self.floorobj=floorobj
		floorobj.visiblefromallphases=true

		
		local scenario=self

			
		self.worldmarkercontroller=XPRACTICE.RYGELONARENA.WorldMarkerController.new()
		self.worldmarkercontroller:Setup(self.game.environment_gameplay)
		
		
		-- self.scheduler=XPRACTICE.RYGELONARENA.Scheduler.new()
		-- self.scheduler:Setup(self.game.environment_gameplay)
		-- self.scheduler.scenario=self
		
		
		XPRACTICE.RYGELONARENA.AddCircle(self,30.83,26.10)
		XPRACTICE.RYGELONARENA.AddCircle(self,23.12,21.84)
		XPRACTICE.RYGELONARENA.AddCircle(self,28.28,35.03)
		XPRACTICE.RYGELONARENA.AddCircle(self,24.04,28.72)
		XPRACTICE.RYGELONARENA.AddCircle(self,20.82,36.02)
		XPRACTICE.RYGELONARENA.AddCircle(self,16.32,28.42)
		XPRACTICE.RYGELONARENA.AddCircle(self,16.26,41.85)
		XPRACTICE.RYGELONARENA.AddCircle(self,12.65,35.68)
		XPRACTICE.RYGELONARENA.AddCircle(self,7.32,40.46)
		XPRACTICE.RYGELONARENA.AddCircle(self,7.46,31.22)
		--
		XPRACTICE.RYGELONARENA.AddCircle(self,37.95,14.01)
		XPRACTICE.RYGELONARENA.AddCircle(self,30.51,9.39)
		XPRACTICE.RYGELONARENA.AddCircle(self,44.73,7.01)
		XPRACTICE.RYGELONARENA.AddCircle(self,37.09,5.55)
		XPRACTICE.RYGELONARENA.AddCircle(self,42.06,-0.21)
		XPRACTICE.RYGELONARENA.AddCircle(self,32.96,-0.22)
		XPRACTICE.RYGELONARENA.AddCircle(self,44.69,-7.44)
		XPRACTICE.RYGELONARENA.AddCircle(self,37.25,-6.05)
		XPRACTICE.RYGELONARENA.AddCircle(self,38.21,-14.31)
		XPRACTICE.RYGELONARENA.AddCircle(self,30.57,-9.22)

	
	
		XPRACTICE.BossDebugButton.ResetPosition()
		self.bossdebugbuttons={}
		local button
		
		XPRACTICE.BossDebugButton.debugbuttony=XPRACTICE.BossDebugButton.debugbuttony+52
		XPRACTICE.BossDebugButton.debugbuttony=XPRACTICE.BossDebugButton.debugbuttony+52
		XPRACTICE.BossDebugButton.debugbuttony=XPRACTICE.BossDebugButton.debugbuttony+52
		--self.getplayerpositionbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.INDIGNATION.Spell_GetPlayerPosition,self.spellbunny)
		
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_Help,self.spellbunny,"HELP")
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_CallToArms,self.spellbunny,"CALL")
		
		XPRACTICE.BossDebugButton.CarriageReturn()		
		XPRACTICE.BossDebugButton.CarriageReturn()
		
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52		
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52		
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52		
		-- self.dashbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_Sprint,self.spellbunny,"DASH")
		-- self.roarbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_Roar,self.spellbunny,"ROAR")
		-- self.pallybubblebutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_PallyBubble,self.spellbunny,"INVUL\n5 SEC")
		-- self.brezbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_Brez,self.spellbunny,"ANKH")
		
		XPRACTICE.BossDebugButton.CarriageReturn()
		
		XPRACTICE.BossDebugButton.CarriageReturn()
		self.getplayerpositionbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.INDIGNATION.Spell_GetPlayerPosition,self.spellbunny)
		-- self.debugbutton=			 XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_AddCircle,self.spellbunny,"ADD\nSOAK")
		-- self.debugbutton=			 XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_MoveCircle,self.spellbunny,"MOVE\nSOAK")
		-- self.debugbutton=			 XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_ReportCircle,self.spellbunny,"LOC\nSOAK")
		
		
		-- self.swirlsyncstopbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_SwirlSync_Stop,self.spellbunny,"SWIRL\nSTOP")
		-- self.resetstacksbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_ResetStacks,self.spellbunny,"RESET\nSTACK")
		
		-- XPRACTICE.BossDebugButton.CarriageReturn()
		-- self.humanappearancebutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_HumanAppearance,self.spellbunny,"HMN")
		-- self.lichappearancebutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.RYGELONARENA.Spell_LichAppearance,self.spellbunny,"LICH")		
		-- XPRACTICE.BossDebugButton.CarriageReturn()
		
		for i=1,#self.bossdebugbuttons do
			self.bossdebugbuttons[i]:SetLockedStartingAlpha(1);self.bossdebugbuttons[i]:EnableMouse(true) --TODO:
		end
		

		self.worldmarkercontroller:LoadAll(self,true)

		local label=XPRACTICE.HelpLabel.new()		
		label:Setup(self.game.environment_gameplay)
		--label.position={x=150,y=self.game.SCREEN_HEIGHT/2,z=0}
		label.position={x=150,y=250,z=0}
		label:SetSize(800,600)
		local message="UNSTABLE MATTER FIELD\r\r"..
						"Multiple players are required.\r"..
						"This is a \"raid planning\" scenario rather than a \"practice\" scenario.\r"..
						"The 20 soaking circles will always appear in the same layout relative to the Unstable Matter behind Rygelon.  "..
						"Before pulling the boss, make sure all 20 players have a unique circle assigned to them.\r\r"..
						"If you are a raid officer, the CALL button will summon all other players into this scenario.  Use it wisely!\r"
		--label:SetText("test")
		label:SetText(message)
		label.alpha=0;label.displayobject.drawable:SetAlpha(0)
		self.helplabel=label	
		

		
		if(self.multiplayer.joinedsolo)then
			self.statuslabel:SetText("You are not in a group!\nJoin a group to enable multiplayer features.",nil)
		end
		
		
	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		if(self.populationlabel)then
			local playercount=0
			for k,v in pairs(self.multiplayer.allplayers)do
				playercount=playercount+1
			end
			self.populationlabel:SetText("Player count: "..tostring(playercount))
		end
		
		
		if(self.player and self.spectating)then
			if(self.player.velocity.x~=0 or self.player.velocity.y~=0 or self.player.velocity.z~=0)then
				self.spectating=false
				self.game.environment_gameplay.cameramanager.camera.focus=self.player
			end
		end
		
		

		if(self.layout and self.player)then
			self.layout:DebugCheck()
		end

		
		---------------------------------------------------------------
		-- HIT DETECTION
		---------------------------------------------------------------
		
		if(self.player)then
			--self.collision:OutOfBoundsCheck()			
			--self.collision:DebuffCheck()
			self.collision:CircleCheck()
		end
		
		-------------------------------------------------------------------------------
		-- GAME END DETECTION
		-------------------------------------------------------------------------------		


		
		
		------------------------------------------------------------------------------
		-- FAKE COMBAT LOG MESSAGES
		------------------------------------------------------------------------------
		
		--
		
		------------------------------------------------------------------------------
		-- MENU BUTTONS
		------------------------------------------------------------------------------	
	
		

		
		
		------------------------------------------------------------------------------
		-- TIMED EVENTS
		------------------------------------------------------------------------------	
		-- process this loop forward so events are executed usually in the order they are queued
		
		for i=1,#self.events do
			local event=self.events[i]
			if(self.stopallevents==false or event.alwayshappens)then
				if(self.game.environment_gameplay.localtime>=event.time)then
					--print("event",event,event.time)
					if(event.button)then
						event.button:BossButtonClick()				
					end
					if(event.func)then
						event.func(self)
					end
					event.dead=true
					--TODO LATER: due to the way spell queues are currently set up, queueing up two buttons on the same frame will overwrite the former spell with the latter
					-- so for now, we break to limit one event per frame
					break
				end
			end
		end

		-- removal loop goes backward as usual
		for i=#self.events,1,-1 do
			if(self.events[i].dead)then
				tremove(self.events,i)
			end
		end
		
	end
	
	
	function class:UpdatePlayerFloorbelowStatus()
	
		for k,v in pairs(self.multiplayer.allplayers)do
			local player=v
			if(self.player.floorbelow==false and self.player.position.z<0)then 
				return 
			end
			local ok=self.collision:EdgeCheck(player)
			player.floorbelow=ok
			
		end
	
		-- --overridden function is base scenario class, so we can't move the entire thing to collision
		-- if(not self.player)then return end
		-- if(not self.player.inphase)then
			-- self.player.floorbelow=true
			-- return
		-- end
		
		-- if(self.player.floorbelow==false and self.player.position.z<0)then 
			-- return 
		-- end
		
		-- local ok=self.collision:EdgeCheck(0)
		-- -- if(ok==false)then	-- this secondary check is only needed for line-based boundary check
			-- -- ok=self.collision:OutOfBoundsCheck(-0.01) or self.collision:OutOfBoundsCheck(-0.01)
		-- -- end
		-- self.player.floorbelow=ok
	end
	


	function class:Brez()
		local auras=self.player.combatmodule.auras:GetAurasByClassIfExist(XPRACTICE.RYGELONARENA.Aura_ChangePhaseForced)
		if(#auras>0)then 			
			return 
		end				
		if(self.player.position.z<0)then
			return
		end
	
		local auras=self.player.combatmodule.auras.deadingame
		if(#auras==0)then 
			self.statuslabel:SetText("You're not dead yet.",3.0)
			return 
		end
		local auras=self.player.combatmodule.auras.deadingame
		for i=1,#auras do
			auras[i]:Die()
		end
		
	
		
		self.player.portaldebuff=false
		self.player.velocity.x=0
		self.player.velocity.y=0
		self.player.velocity.z=0				

		self.statuslabel:SetText("Brezzed.",3.0)
		self.multiplayer:FormatAndSendCustom("BREZ")
	end




	function class:EnableButtons(buttongroup,toggle)
		for i=1,#buttongroup do
			local button=buttongroup[i]
			if(toggle)then
				button.displayobject.drawable:SetAlpha(1) -- for labels
				button.alpha=1
				button:SetLockedStartingAlpha(1.0)	-- for buttons
			else
				button.displayobject.drawable:SetAlpha(0)
				button.alpha=0
				button:SetLockedStartingAlpha(0.0)
			end
			button:EnableMouse(toggle)
		end
	end	
	
	
	function class:DeselectButtons(buttongroup)
		for i=1,#buttongroup do
			local button=buttongroup[i]
			button:Select(false)
		end
	end
	


	function class:ClickButtonAfterDelay(button,delay)		
		if(delay<0)then return end --cheap way to skip events when we fastforward
		local event={}
		event.button=button
		event.time=self.game.environment_gameplay.localtime+delay
		event.dead=false
		tinsert(self.events,event)
	end
	
	function class:FunctionAfterDelay(func,delay)		
		if(delay<0)then return end --cheap way to skip events when we fastforward
		local event={}
		event.func=func
		event.time=self.game.environment_gameplay.localtime+delay
		event.dead=false
		tinsert(self.events,event)
	end
	

	
	function class:OnRoomLock(hostname)
		--self.statuslabel:SetText(hostname.." is sending data.  The encounter will start momentarily...",3.0)
		self.statuslabel:SetText(hostname.." has started the encounter!",3.0)
		self.phaseinprogress=true
		self.totaldeaths=0
		
		if(self.multiplayer.host)then
			--
		end
	end
	

	function class:OnRoomUnlock(hostname,noofficers,acknowledge)
		--if(not self.multiplayer.roomlocked)then return end   --this doesn't work: room is ALREADY unlocked
		
		self:BrezAllPlayers()
		
		if(self.scheduler)then self.scheduler:Deactivate() end
		
		self.debuffsactive=false
		self.guiddebuffs={}
		self.reportedcollisionlist={}
		
		
		
		if(not self.multiplayer.joinedgameinprogress)then
			if(not noofficers)then
				if(self.phaseinprogress)then
					self.statuslabel:SetText(hostname.." ended the encounter.",3.0)
				end
			else
				if(self.phaseinprogress)then      
					self.statuslabel:SetText("The host has left the room.  The encounter ends.",3.0)
				end
			end					
			self.multiplayer:SendIExist()
		else
			self.multiplayer.joinedgameinprogress=false
			self.statuslabel:SetText("The encounter in progress has ended.  You will now join the room.",3.0)
			self.multiplayer:SendHello()
		end		
		self.totaldeaths=0
		self.timeelapsed=0
		self.reportedtimeup=false
		self.lastreportedtime=0
		self.phaseinprogress=false
		self.resultstimer=nil
		self.endtimer=nil

		

	end

	function class:OnRoomAlreadyInProgress(sender)
		self.statuslabel:SetText("An encounter is already in progress!\nYou will automatically join the room when the encounter ends.",nil)
	end
	
	function class:OnCustomMessage(msgcode,sender,args)
		
	end
	
	function class:OnEscapeKey()
		if(self.gamemenu)then
			if(self.gamemenu.shown)then
				self.gamemenu:Hide()
			else
				local ok=true
				if(self.player)then					
					if(self.player.combatmodule.targetmob)then
						ok=false
					end
				end
				if(ok)then
					self.gamemenu:Show()
				end
			end
		end
	end	
	
	function class:AttemptKillPlayer(player,ignorebubble)
		if(player:IsDeadInGame())then return false end
		--TODO: move to base mob
		for i=1,#player.combatmodule.auras.newauras do
			local aura=player.combatmodule.auras.newauras[i]
			if(aura:Class()==XPRACTICE.Aura_DeadInGame)then return false end
			--print(aura.class)
		end
		
		local auras=player.combatmodule.auras:GetAurasByClassIfExist(XPRACTICE.RYGELONARENA.Aura_PallyBubble)
		if(#auras>0 and ignorebubble~=true)then
			return false
		else			
			--print("AKP",player,ignorebubble)
			local aura=player.combatmodule:ApplyAuraByClass(XPRACTICE.Aura_DeadInGame,player.combatmodule,player.environment.localtime)	
			self.totaldeaths=self.totaldeaths+1	
			return true
		end
	end
	
	function class:BrezAllPlayers()
		--print("Current?:",self.multiplayer.allplayers)
		for k,v in pairs(self.multiplayer.allplayers) do
			--print("Rez player",k,v)
			local player=v		
			local auras=player.combatmodule.auras.deadingame
			if(#auras>0)then
				for i=1,#auras do
					auras[i]:Die()
				end
				player.ai.targetposition=nil
			end
		end
		for k,v in pairs(self.multiplayer.previousplayerghosts) do
			local player=v		
			local auras=player.combatmodule.auras.deadingame
			if(#auras>0)then
				for i=1,#auras do
					auras[i]:Die()
				end
				player.ai.targetposition=nil			
			end
		end
	end
	
	
	XPRACTICE.ScenarioList.RegisterScenario(XPRACTICE.RYGELONARENA.Scenario,"Unstable Matter Field","(Rygelon)","SCENARIO")
end

