do
	local super=XPRACTICE.Aura
	XPRACTICE.THEJAILER2.Aura_ExplosiveRunes = XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.THEJAILER2.Aura_ExplosiveRunes
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.tickcount=0
		--if(not IsInGroup(unit))then --TODO NEXT: "unit" is undefined -- JAILER3 is probably broken
		if(true)then
			self.baseduration=7.0
			self.tickoffset=0
		else
			self.baseduration=6.5	--using communication lag trickery to sync everyone up.
			self.tickoffset=-3					--TODO NEXT: option to set baseduration to 7.0 even in groups, in case there isn't enough lag
		end
		self.basetickrate=0.25
	end
	
	function class:OnApply(localtime)
		super.OnApply(self,localtime)
		local mob=self.targetcombat.mob
		mob.scenario.player.alreadysentrune1hostmessage=false
		mob.scenario.player.alreadyreceivedrune1hostmessage=false
		local effect=XPRACTICE.THEJAILER2.ExplosiveRunesVisualEffect.new()
		effect.player=mob
		effect:Setup(mob.environment,mob.position.x,mob.position.y,mob.position.z+0)		
		self.visualeffect=effect
	end	
	
	function class:Tick(ticktime)
		self:OnTick(ticktime,1.0)
		--!!!
		--TODO: move to base aura class
		self.previousticktime=ticktime
	end	
	function class:OnTick(ticktime,percentage)
		local mob=self.targetcombat.mob
		local scenario=mob.scenario
		self.tickcount=self.tickcount+1

		if(self.tickcount==1)then
			mob:CreateSpeechBubble("BOMB: "..self.hole)
			self.correctpylonid=XPRACTICE.THEJAILER2.ExplosiveRunesManager.holes[self.hole][self.set]
			local pylon=scenario.layout.pylonmanager.pylons[self.correctpylonid]
			self.pylonx=pylon.position.x
			self.pylony=pylon.position.y
			self.destx=pylon.position.x+6.5*math.cos(XPRACTICE.THEJAILER2.ExplosiveRunesManager.waitingangles[self.hole]+(-math.pi/3*(self.set-1)))
			self.desty=pylon.position.y+6.5*math.sin(XPRACTICE.THEJAILER2.ExplosiveRunesManager.waitingangles[self.hole]+(-math.pi/3*(self.set-1)))
			-- mob:SuggestDestination(self.destx,self.desty,math.random()*1.0+0.5)
			-- if(mob.scenario.player==mob)then
				-- mob.scenario:PlaceHintArrow(self.destx,self.desty)
			-- end			
		elseif(self.tickcount==6)then
			self.visualeffect.animationmodule:PlayAnimation(XPRACTICE.THEJAILER2.AnimationList.ExplosiveRuneCustom)
			if(mob.rolepointer and not mob.rolepointer.playerghostpointer)then
				local aura=mob.combatmodule:ApplyAuraByClass(XPRACTICE.THEJAILER2.Aura_DeathGrip_GhostCheat)
				aura.destination={x=self.destx,y=self.desty,z=0}
			end
		elseif(self.tickcount==13+self.tickoffset)then
			--mob:CreateSpeechBubble("WAIT 3")
			--mob:SuggestOrientation(math.atan2(self.pylony-mob.position.y,self.pylonx-mob.position.x))
			--TODO: CPUs should backpedal or sidestep into holes when appropriate (but remember to turn around in midair)
		elseif(self.tickcount==17+self.tickoffset)then
			--mob:CreateSpeechBubble("WAIT 2")
		elseif(self.tickcount==21+self.tickoffset)then
			--mob:CreateSpeechBubble("WAIT 1")
		elseif(self.tickcount==24+self.tickoffset)then	-- 1.5 seconds before expiry.  aura expires on tick 29
		--elseif(self.tickcount==25+self.tickoffset)then	-- 1.25 seconds before expiry.  aura expires on tick 29
			--mob:CreateSpeechBubble("\124cffff3f40".."JUMP NOW".."\124r")
			-- mob:SuggestDestination(self.pylonx,self.pylony,0)
			-- if(mob.scenario.player==mob)then
				-- mob.scenario:PlaceHintArrow(self.pylonx,self.pylony)
			-- end			
		elseif(self.tickcount==26+self.tickoffset)then	
			-- if(mob.rolepointer and not mob.rolepointer.playerghostpointer)then	--TODO: "IsMobCPUControlled" function
				-- mob.floorbelow=false
			-- end
		end
	end
	
	function class:OnRemove()
		super.OnRemove(self)		
		--self.visualeffect.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileDespawnCustomDuration)	--moved to RUNE_LAUNCH
		local mob=self.targetcombat.mob
		local scenario=mob.scenario
		local correctpylonid=string.char(XPRACTICE.THEJAILER2.ExplosiveRunesManager.holes[self.hole][self.set])
		
		local aura=mob.combatmodule:ApplyAuraByClass(XPRACTICE.THEJAILER2.Aura_AfterRunes1)
		aura.correctpylonid=self.correctpylonid
		aura.visualeffect=self.visualeffect
		if(mob.rolepointer and not mob.rolepointer.playerghostpointer)then			
			if(XPRACTICE.MULTIPLAYER.IsRealOfficer(scenario.multiplayer.myfullname) and not scenario.player.alreadysentrune1hostmessage)then
				if(not scenario.player.alreadysentrune1hostmessage)then					
					scenario.multiplayer:FormatAndSendCustom("RUNE_LAUNCH",mob.position.x,mob.position.y,mob.position.z,mob.velocity.x,mob.velocity.y,mob.velocity.z,mob.orientation.yaw,correctpylonid,correctpylonid,true)
					scenario.player.alreadysentrune1hostmessage=true
				end
			end
		else
			--TODO: calculate which hole we're all in, send RUNE_LAUNCH statement (basically MIDAIR but not ignored by self, also no jumpanim arg)
													-- also for RUNE_LAUNCH, if sent by self, launch the ghosts with RestoreCPUFloor								
			if(scenario.player==mob)then
				--mob.correctpylon=scenario.layout.pylonmanager.pylons[XPRACTICE.THEJAILER2.ExplosiveRunesManager.holes[self.hole][self.set]]
				
				local whichholeid="X"
				if(mob.position.z<=0)then
					local tolerance=7.0
					for i=1,#scenario.layout.pylonmanager.pylons do
						local pylon=scenario.layout.pylonmanager.pylons[i]
						local xdist=pylon.position.x-mob.position.x
						local ydist=pylon.position.y-mob.position.y
						local dist=math.sqrt(xdist*xdist+ydist*ydist)
						--print("Dist:",dist)
						if(dist<=tolerance)then
							whichholeid=string.char(i)
						end
					end
				end
				--TODO: race condition where if CPU aura is removed first, host may send RUNE_LAUNCH twice in one frame
				scenario.multiplayer:FormatAndSendCustom("RUNE_LAUNCH",mob.position.x,mob.position.y,mob.position.z,mob.velocity.x,mob.velocity.y,mob.velocity.z,mob.orientation.yaw,correctpylonid,whichholeid,false)
				scenario.player.alreadysentrune1hostmessage=true
			end
		end		
	end
	

	
end

do
	local super=XPRACTICE.Aura
	XPRACTICE.THEJAILER2.Aura_AfterRunes1 = XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.THEJAILER2.Aura_AfterRunes1
	function class:SetCustomInfo()
		super.SetCustomInfo(self)		
		self.baseduration=2.0		
	end
	function class:OnRemove()
		super.OnRemove(self)
		local mob=self.targetcombat.mob
		if(mob.rolepointer and not mob.rolepointer.playerghostpointer)then
			mob.floorbelow=true	--this aura is only applied to CPU players, don't need to check for CPU status twice
			if(mob.velocity.z<0 and mob.position.z<0)then		
				mob.position.z=0;mob.velocity.z=0	-- failsafe in case RUNE_LAUNCH is delayed
			end
		end
	end		
end

do
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.THEJAILER2.ExplosiveRunesVisualEffect=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.THEJAILER2.ExplosiveRunesVisualEffect
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(4256404)	--9fx_raid3_jailer_debuff_above
			self.displayedpositionoffset={x=0.75,y=0,z=1}
		end
		function class:SetDefaultAnimation()
			self.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileSpawnCustomDuration)
			self.projectilespawncustomduration=1.0
			self.projectileloopcustomduration=6.0
			self.projectiledespawncustomduration=0.1
		end	
		function class:Step(elapsed)
			super.Step(self,elapsed)
			self.position.x=self.player.position.x
			self.position.y=self.player.position.y
			self.position.z=self.player.position.z+0
			if(self.player:IsDeadInGame() and self.state==nil)then
				self.state=1
				self.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileDespawnCustomDuration)
			end
		end
	end	
end


do
	local roomnumber=XPRACTICE.THEJAILER2.NPCID
	local roomBCD=XPRACTICE.MULTIPLAYER.Datatypes.BCD.ToString(XPRACTICE.THEJAILER2.NPCID)	
	do	
		local messagecode=XPRACTICE.MULTIPLAYER.previouscustomcode		
		messagecode=messagecode+1
		local BCDmessagecode=XPRACTICE.MULTIPLAYERV2.Datatypes.ShortBCD.ToString(messagecode)
		local messagename="RUNE_LAUNCH"
		local super=XPRACTICE.MULTIPLAYER.Message
		local lambda=XPRACTICE.inheritsFrom(super)
		local class=lambda	
		function class:SetCustomInfo()
			self.messagename=messagename;self.messagecode=messagecode;self.BCDmessagecode=BCDmessagecode
			self.ignoreself=false
			self.argtypes={	{XPRACTICE.MULTIPLAYER.Datatypes.BCD,4},
							{XPRACTICE.MULTIPLAYER.Datatypes.BCD,4},
							{XPRACTICE.MULTIPLAYER.Datatypes.BCD,4},
							{XPRACTICE.MULTIPLAYER.Datatypes.BCD,4},
							{XPRACTICE.MULTIPLAYER.Datatypes.BCD,4},
							{XPRACTICE.MULTIPLAYER.Datatypes.BCD,4},
							{XPRACTICE.MULTIPLAYER.Datatypes.BCD,6},
							{XPRACTICE.MULTIPLAYER.Datatypes.CHAR},	-- correct pylon ID
							{XPRACTICE.MULTIPLAYER.Datatypes.CHAR},	-- actual pylon ID
							{XPRACTICE.MULTIPLAYER.Datatypes.BOOLEAN}} -- fake CPU message
		end	
		XPRACTICE.MULTIPLAYER["CUSTOM_"..roomBCD].Messagetypes[messagename]=lambda.new();XPRACTICE.MULTIPLAYER["CUSTOM_"..roomBCD].Messagetypes[messagename]:Setup()
		XPRACTICE.MULTIPLAYER["CUSTOM_"..roomBCD].MessagetypesBCDPointer[BCDmessagecode]=XPRACTICE.MULTIPLAYER["CUSTOM_"..roomBCD].Messagetypes[messagename]		
							
		XPRACTICE.MULTIPLAYER.previouscustomcode=messagecode
	end
	
	local class=XPRACTICE.THEJAILER2.Multiplayer
	function class.HandleCustom_RUNE_LAUNCH(self,sender,args)
		local scenario=self.scenario
		local ghost=self.allplayers[sender]
		local playeraura=nil
		if(ghost==scenario.player or (XPRACTICE.MULTIPLAYER.IsRealOfficer(sender)))then
			if(not scenario.player.alreadyreceivedrune1hostmessage)then
				for i=1,#scenario.allpcs do
					local pc=scenario.allpcs[i]				
					local auras=pc.combatmodule.auras:GetAurasByClassIfExistIncludingNewAuras(XPRACTICE.THEJAILER2.Aura_AfterRunes1)
					if(#auras>0)then
						auras[1].visualeffect.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileDespawnCustomDuration)
						if(pc.rolepointer and not pc.rolepointer.playerghostpointer)then						
							local pylonid=auras[1].correctpylonid
							--print("raisepylon? (ghost)",pylonid)
							--scenario.layout.pylonmanager:RaisePylon(scenario.layout.pylonmanager.pylons[pylonid])
							self:LaunchCharacter(pc)						
						end
					end
				end
			end		
		end
		if(args[10]==true)then return end
		if(not ghost)then return end
		if(not ghost:IsDeadInGame())then
			--TODO: if this is our own character, the position/yaw stuff is a few seconds old, BUT ignoring it will desync w/other players.  maybe solve.
			ghost.position.x=args[1]
			ghost.position.y=args[2]
			ghost.position.z=args[3]
			ghost.orientation.yaw=args[7]

			----ghost.velocity.x=args[4]		-- this makes no difference, we're about to launch them
			----ghost.velocity.y=args[5]
			----ghost.velocity.z=args[6]
			
			--must reset ghost AI too.
			--otherwise, ghost AI will still try to move to place it jumped from, and ends up facing backwards
			ghost:StopAI()
		end
		if(args[9]=="X")then
			-- for i=1,#scenario.allpcs do
				-- scenario:AttemptKillPlayer(scenario.allpcs[i])	--TODO: if Myself wasn't in a pylon, die of embarrassment
			-- end
			--TODO LATER: resolve race condition for statuslabel message when one player wipes the raid and another player is in wrong hole
			if(scenario.player:IsDeadInGame())then 
				--TODO NEXT: bandage fix for player blowing up after they ring out and are placed back on the field. (needs fixing in JAILER3 too)
				return 
			end	
			scenario.statuslabel:SetText(sender.." was not in a pylon when their rune expired.")			
			scenario:AttemptKillPlayer(ghost)
		else
			self:LaunchCharacter(ghost)
			local pylonid=string.byte(args[9])
			--print("raisepylon? (personal)",pylonid)
			--scenario.layout.pylonmanager:RaisePylon(scenario.layout.pylonmanager.pylons[pylonid])
			if(ghost==scenario.player)then
				if(args[8]~=args[9])then
					scenario:AttemptKillPlayer(ghost,true)	--TODO: "die of embarrassment")
					XPRACTICE_RaidBossEmote("Wrong pylon conduit!  Try again...",5.0,true)	
				else
					--XPRACTICE_RaidBossEmote("Correct!",5.0,true)
					--TODO: if player lands on ground without dying, "correct" message
					scenario.player.correct_pending=true
				end
			end
		end		
	end			
	
	function class:LaunchCharacter(pc)
		if(not pc:IsDeadInGame())then 
			pc.velocity.x=math.cos(pc.orientation.yaw)*-7
			pc.velocity.y=math.sin(pc.orientation.yaw)*-7
			pc.velocity.z=40
		end
		--reset ghost AI too
		pc:StopAI()
	end
end