do
	--TODO: volatile code reuse -- only use function in multiplayer/messagehandler.lua
	local function IAmGameHost(multiplayer)
		if(not IsInGroup("player"))then return true end
		if(multiplayer.host)then return true end
		return false		
	end
	



	do
		XPRACTICE.THEJAILER2.Event = {}
		local class=XPRACTICE.THEJAILER2.Event
		class.__index = class
		function class.new()
			local self=setmetatable({}, class)
			return self
		end
		function class:Setup(scenario)
			self.scenario=scenario
			self.time=nil
			self.func=nil
		end
		function class:SetTime(m,s)
			self.time=m*60+s
		end

	end

	

	do
		local super=XPRACTICE.GameObject
		XPRACTICE.THEJAILER2.Schedule=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.THEJAILER2.Schedule
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)		
			self.events={}
			self.time=0
			self.nexteventid=nil
		end
		
		function class:NewEvent(m,s,func)
			local event=XPRACTICE.THEJAILER2.Event.new()
			event:Setup(self.scenario)
			event:SetTime(m,s)
			event.done=false
			event.func=func
			tinsert(self.events,event)
			return event
		end
		
		function class:GotoTime(newtime)
			self.time=newtime
			self.nexteventid=nil
			for i=1,#self.events do
				local event=self.events[i]
				if(event.time<newtime)then
					event.done=true
				else
					if(not self.nexteventid)then self.nexteventid=i end
					event.done=false
				end
			end			
		end
		

			

		function class:SetCamp(players,cx,cy,radius,minreaction,maxreaction)
			radius=radius or 0
			minreaction=minreaction or 0
			maxreaction=maxreaction or 0
			for k,v in pairs(players) do
				local x,y=XPRACTICE.RandomPointInCircle(cx,cy,radius)
				local reactiontime=minreaction+(maxreaction-minreaction)
				v:SetCamp(x,y,nil,reactiontime)
			end
		end
		
		function class:SetAllCamp(cx,cy,radius,minreaction,maxreaction)
			local players={unpack(self.scenario.allpcs)}
			self:SetCamp(players,cx,cy,radius,minreaction,maxreaction)
		end
		
		
		function class:SetRangedCamp(cx,cy,radius,minreaction,maxreaction)
			local players={}
			for k,v in pairs(self.scenario.allpcs) do
				if(v.rolepointer and (v.rolepointer.healer or v.rolepointer.rdps))then
					tinsert(players,v)
				end
			end
			self:SetCamp(players,cx,cy,radius,minreaction,maxreaction)
		end

		function class:SetMeleeCamp(cx,cy,radius,minreaction,maxreaction)
			local players={}
			for k,v in pairs(self.scenario.allpcs) do
				if(v.rolepointer and (v.rolepointer.mdps))then
					tinsert(players,v)
				end
			end
			self:SetCamp(players,cx,cy,radius,minreaction,maxreaction)
		end

		function class:GetExpectedPosition(mob)
			local x=mob.position.x
			local y=mob.position.y
			local x2,y2=nil,nil
			if(mob.camps[1] and not mob.camps[1].go)then
				x=mob.camps[1].x
				y=mob.camps[1].y
			elseif(mob.ai.targetposition)then
				x=mob.ai.targetposition.x
				y=mob.ai.targetposition.y
			elseif(mob.destx and mob.desty)then
				x=mob.destx
				y=mob.desty			
			elseif(mob.camps[1])then
				x=mob.camps[1].x
				y=mob.camps[1].y
			end
			if(mob.camps[2])then
				x2=mob.camps[2].x
				y2=mob.camps[2].y
			end
			return x,y,x2,y2
		end

		function class:OnePlayerFaceBoss(v,boss)	-- where "v" is player
			local bossx,bossy=self:GetExpectedPosition(boss)
			local playerx,playery,x2,y2=self:GetExpectedPosition(v)	
			local disty=bossy-playery
			local distx=bossx-playerx			
			local yaw=math.atan2(disty,distx)
			if(v.camps[1])then
				v.camps[1].yaw=yaw
			elseif(v.destx)then
				v.destyaw=yaw
			else
				v:SuggestOrientation(yaw)
			end
			if(v.camps[2])then					
				if(x2 and y2)then
					local yaw2=math.atan2(bossy-y2,bossx-x2)						
					v.camps[2].yaw=yaw2
				end					
			end		
			
		end

		function class:EverybodyFaceBoss()
			local boss=self.scenario.boss
			for k,v in pairs(self.scenario.allpcs) do
				--TODO LATER: this loop unnecessarily recalculates boss position 20 times
				self:OnePlayerFaceBoss(v,boss)
			end
		end
		
		function class:EverybodyLockGate(gate)
			for k,v in pairs(self.scenario.allpcs)do
				local reaction=0.5+math.random()*2.5
				if(v.rolepointer.melee or v.rolepointer.tank)then reaction=3.5+math.random()*1.5 end
				-- now a bit of trickery so EverybodyFaceBoss works as expected...
				v:SetCamp(gate.position.x,gate.position.y,nil,math.random()*0.5)
				v:SuggestLockGate(gate,reaction)
				local schedule=self
				-- TODO LATER: whoa hang on, portal calls StopAI which destroys any other existing camp setup.  what do?
						-- maybe "camp persists through stopai" flag?				
			end
		end
		
		function class:OnePlayerToNearestHidingPlace(player,list,minreaction,maxreaction)
			minreaction=minreaction or 0
			maxreaction=maxreaction or 0		
			local v=player
			local mindist=nil
			local reactiontime=minreaction+(maxreaction-minreaction)*(math.pow(math.random(),2))			
			local destx,desty			
			--print("#list:",#list)
			for i=1,#list do				
				local distx=list[i][1]-v.position.x
				local disty=list[i][2]-v.position.y
				local dist=math.sqrt(distx*distx+disty*disty)
				if((not mindist) or dist<mindist)then
					mindist=dist
					destx=list[i][1]
					desty=list[i][2]
				end					
			end
			if(destx and desty)then
				self:SetCamp({v},destx,desty,1,minreaction,maxreaction)
			end
		end
		
		function class:PlayersToNearestHidingPlace(group,list,minreaction,maxreaction)
			for k,v in pairs(group)do
				self:OnePlayerToNearestHidingPlace(v,list,minreaction,maxreaction)
			end		
		end
		
		function class:EverybodyToNearestHidingPlace(list,minreaction,maxreaction)
			self:PlayersToNearestHidingPlace(self.scenario.allpcs,list,minreaction,maxreaction)
		end
		
		function class:DealWithMartyrdom(index)			
			local target=self.scenario.boss.combatmodule.targetmob or self.scenario.boss1
			local group
			if(index%2==1)then group=1 else group=2 end
			local soakgroup=XPRACTICE.THEJAILER2.ChoreographyPhase1.martyrdom[group]
			for i=1,20 do
				local pc=self.scenario.roles[i].mob
				if(pc~=target)then					
					local soaking=false
					for j=1,#soakgroup do
						if(soakgroup[j]==i)then
							soaking=true;j=#soakgroup+1
						end
					end
					if(pc==self.scenario.player)then
						if(XPRACTICE_SAVEDATA.THEJAILER2.tanksoak==1)then
							if(index%2==1)then soaking=true else soaking=false end
						elseif(XPRACTICE_SAVEDATA.THEJAILER2.tanksoak==2)then
							if(index%2==0)then soaking=true else soaking=false end
						end
					end
					if(soaking)then
						self:OnePlayerToNearestHidingPlace(pc,XPRACTICE.THEJAILER2.ChoreographyPhase1.martyrsoak[index],0,0.25)
						pc:SuggestRoll(0.25)
					else
						local distx=target.position.x-pc.position.x
						local disty=target.position.y-pc.position.y
						local dist=math.sqrt(distx*distx+disty*disty)
						if(dist<=11)then							
							if(index==1 or index==3 or index==4)then
								self:OnePlayerToNearestHidingPlace(pc,XPRACTICE.THEJAILER2.ChoreographyPhase1.martyravoid[index],0,1.0)
								if(index==4)then 
									if(pc.rolepointer and not pc.rolepointer.playerghostpointer)then
										--TODO LATER: SuggestSprint
										if(pc.camps[1])then pc.camps[1].reactiontime=0 end
										local auras=pc.combatmodule.auras.speedboost
										if(#auras>0 and not auras[1].dying)then
											local newexpiry=pc.environment.localtime+8.000
											if(newexpiry>auras[1].expirytime)then auras[1].expirytime=newexpiry end
											auras[1].multiplier=1.7
										else
											local aura=pc.combatmodule:ApplyAuraByClass(XPRACTICE.Aura_StampedingRoar,pc.combatmodule,pc.environment.localtime)
											aura.expirytime=pc.environment.localtime+8.000
											aura.multiplier=1.7
										end
									end
								end
							else
								local t=math.atan2(disty,distx)
								self:SetCamp({pc},target.position.x-15*math.cos(t),target.position.y-12*math.sin(t),1,0,1.0)
							end
						end
					end
				end
			end
			-- exception for player hintarrows when not soaking:
			if(XPRACTICE_SAVEDATA.THEJAILER2.tanksoak==0)then				
				if(self.scenario.hintarrow)then self.scenario.hintarrow:Die() end
			end
			self:EverybodyFaceBoss()
		end
		
		function class:CreateAssociatedObjects()
			local schedule=self
			local scenario=self.scenario
			local multiplayer=scenario.multiplayer		
			local tank1=scenario.tank1
			local tank2=scenario.tank2
			local mdps1=scenario.mdps1
			local mdps2=scenario.mdps2
			local mdps3=scenario.mdps3
			local mdps4=scenario.mdps4
			local mdps5=scenario.mdps5
			local boss=scenario.boss
			local spells=scenario.boss.combatmodule.spellbook
			
			self.events={}
			self.nexteventid=1
			
			
			self:NewEvent(0,00,function()
				tank1:SuggestTauntBoss()
				boss:SetCamp(-24.39,21.69)
				tank2:SetCamp(-35.10,17.91)
				mdps1:SetCamp(-31.05,12.37)	-- these are spread positions too
				mdps2:SetCamp(-24.20,10.11)
				mdps3:SetCamp(-15.37,15.20)
				mdps4:SetCamp(-13.45,22.01)				
				mdps5:SetCamp(-16.15,29.38)
				mdps5:SetTemporaryCamp(-19.41,27.19,nil,nil,3.5)	-- discourage mdps5 from running over open hatch
				self:EverybodyFaceBoss()
			end)
					

			self:NewEvent(0,01,function()
				-- World Crusher
				if(IAmGameHost(multiplayer))then
					spells.worldcrusher:Broadcast_v2(scenario)
				end								
			end)
			
			self:NewEvent(0,02,function()				
				if(IAmGameHost(multiplayer))then
					scenario.rerolltargetsbutton:BossButtonClick(true)
				end			
				-- tank2:SuggestTauntBoss() --!!!!!!!!!!!!!!
				--self:GotoTime(2*60+0)  --!!!!!!!!!!!!!!
			end)
			
			self:NewEvent(0,03,function() scenario.statuslabel:SetText("Spread out for torment circles.",5.0) end)

			self:NewEvent(0,08,function()
				-- Torment
				if(IAmGameHost(multiplayer))then
					spells.torment1:Broadcast_v2(scenario)
				end				
			end)
			
			self:NewEvent(0,11,function() scenario.statuslabel:SetText("Be ready to lockgate out of grip.",5.0) end)
			
			self:NewEvent(0,16,function()
				if(IAmGameHost(multiplayer))then
					spells.chainsofoppression:Broadcast_v2(scenario)
				end
			 	ActionButton_ShowOverlayGlow(scenario.gateitembutton.displayobject.drawable)
				-- queue up portal use for CPUs
				local gate=scenario.cpulockgates[2]
				self:EverybodyLockGate(gate)
				for k,v in pairs(scenario.allpcs) do
					v.afterlockgatefunc=function()
						-- camp is expected to be nil at this point (gate causes stopai)
						-- face boss immediately, and again after we move back to gate
						v:SetTemporaryCamp(gate.partner.position.x,gate.partner.position.y,nil,0,1.0+math.random(1.5))
						schedule:OnePlayerFaceBoss(v,boss)
						v:SetCamp(gate.partner.position.x,gate.partner.position.y)	
						schedule:OnePlayerFaceBoss(v,boss)
						if(v==tank1)then
							boss:SetCamp(2.36,31.66)
						end
					end
				end
			end)
			
			self:NewEvent(0,16,function() scenario.statuslabel:SetText("Make your way over to 1st bloodsoak positions (10 seconds).",5.0) end)
			
		
			self:NewEvent(0,22,function()
				-- move to bloodsoak1 positions				
				self:SetAllCamp(8.89,30.33,5,0,1.0)
				scenario.allpcs[13]:SetTemporaryCamp(18.86,40.72,nil,math.random()*1.0,3.0)	--rdps1
				scenario.allpcs[14]:SetTemporaryCamp(18.86,40.72,nil,math.random()*1.0,3.0)	--rdps2
				for k,v in pairs(XPRACTICE.THEJAILER2.ChoreographyPhase1.soak1pre) do
					index=tonumber(string.sub(k,2))
					scenario.allpcs[index]:SetCamp(v[1],v[2],nil,math.random()*1.0)
				end
				self:EverybodyFaceBoss()
			end)
						
			self:NewEvent(0,25.5,function()			
				-- -- bloodsoak 1
						-- -- -- TODO LATER: ...this seems to be taken care of already.  soak1pre #13 is wrong-ish
				-- scenario.allpcs[13]:SetCamp(XPRACTICE.THEJAILER2.ChoreographyPhase1.soak1[1],XPRACTICE.THEJAILER2.ChoreographyPhase1.soak1[2])
			end)
			
			self:NewEvent(0,25.5,function() scenario.statuslabel:SetText("Soak now!  Afterwards, group A soaks tank knockback.",5.0) end)
			
			self:NewEvent(0,29,function()		
				if(scenario.bloods and scenario.bloods[1])then
					scenario.bloods[1].fadestarttime=self.environment.localtime
					scenario.bloods[1].expirytime=self.environment.localtime+0.25
				end
			end)			
			
			

			
			self:NewEvent(0,30,function()
				-- martyrdom A			
				if(IAmGameHost(multiplayer))then
					spells.martyrdom:Broadcast_v2(scenario)
					self:DealWithMartyrdom(1)
				end				
			end)
			self:NewEvent(0,30,function() scenario.statuslabel:SetText("Bomb runes soon.",5.0) end)
			
			
					
			self:NewEvent(0,31.5,function()
				tank2:SuggestTauntBoss()
			end)
			
			self:NewEvent(0,33,function()
				-- after martyrdom knockback:
				--melee run back to boss
				for i=8,12 do
					if(scenario.allpcs[i].camps[1])then
						scenario.allpcs[i].camps[1].go=false
						scenario.allpcs[i].camps[1].reactiontime=2.0	-- delay reactiontime enough that players are far enough away from destination
					end
				end
				--tank2 runs in to where tank1 is standing
				tank2:SetCamp(10.62,34.00)
				self:EverybodyFaceBoss()				
			end)
			
			

			
			self:NewEvent(0,35,function()
				-- bombrunes 1
				XPRACTICE.THEJAILER2.ExplosiveRunesManager.nextcast=1
				if(IAmGameHost(multiplayer))then
					spells.explosiverunes:Broadcast_v2(scenario)
				end
			end)		
			
			self:NewEvent(0,39,function() scenario.statuslabel:SetText("LOS behind pillars.",5.0) end)
			
			self:NewEvent(0,44,function()
				-- domination -> tyranny 1
				if(IAmGameHost(multiplayer))then
					spells.relentlessdomination:Broadcast_v2(scenario)
				end				
			end)
			
			self:NewEvent(0,45,function()
				-- domination LOS
				self:EverybodyToNearestHidingPlace(XPRACTICE.THEJAILER2.ChoreographyPhase1.los[1],0,1.0)
				self:EverybodyFaceBoss()
			end)			
			
			self:NewEvent(0,45,function() scenario.statuslabel:SetText("After LOS ends, rotate clockwise + lines + circle spread.\n",5.0) end)
		
			self:NewEvent(0,50,function() scenario.statuslabel:SetText("Be careful not to touch Blood of Azeroth early!",5.0) end)
		
			self:NewEvent(0,50,function()
				-- (LOS ends here)
				-- everyone spread out for torment, somehow
				-- torment
				if(IAmGameHost(multiplayer))then
					spells.torment1:Broadcast_v2(scenario)
				end	
				
				for k,v in pairs(self.scenario.allpcs) do				
					local ghost=v
					local aura=ghost.combatmodule:ApplyAuraByClass(XPRACTICE.Aura_StampedingRoar,ghost.combatmodule,ghost.localtime)
				end
				
				boss:SetCamp(32.04,11.30)
				
				
				for i=1,#XPRACTICE.THEJAILER2.ChoreographyPhase1.torment[2] do
					local dest=XPRACTICE.THEJAILER2.ChoreographyPhase1.torment[2][i]
					if(dest[1] and dest[2])then
						self.scenario.allpcs[i]:SetCamp(dest[1],dest[2],nil,math.pow(math.random(),2))
						self.scenario.allpcs[i]:SuggestRoll(1.0+math.random()*1.0)
					end
				end
				self:EverybodyFaceBoss()
			end)	
			
			
			
			self:NewEvent(0,53,function() scenario.statuslabel:SetText("Bomb runes soon.  (Don't land in blood!)",5.0) end)
			
			self:NewEvent(0,58,function()
				-- bombrunes 2
				XPRACTICE.THEJAILER2.ExplosiveRunesManager.nextcast=2
				if(IAmGameHost(multiplayer))then
					spells.explosiverunes:Broadcast_v2(scenario)
				end
			end)		
			
			
			
			self:NewEvent(1,01,function() scenario.statuslabel:SetText("Make your way over to 2nd bloodsoak positions (10 seconds).\nBombed players might need help!",5.0) end)

			self:NewEvent(1,06,function()
				-- move to bloodsoak2 positions				
				self:SetAllCamp(32.96,6.91,5,0,1.0)
				for k,v in pairs(XPRACTICE.THEJAILER2.ChoreographyPhase1.soak2pre) do
					index=tonumber(string.sub(k,2))
					scenario.allpcs[index]:SetCamp(v[1],v[2],nil,math.random()*1.0)
				end
				self:EverybodyFaceBoss()
			end)		
			
			self:NewEvent(1,07,function()
				for k,v in pairs(scenario.allpcs) do
					if(v.rolepointer and not v.rolepointer.playerghostpointer)then
						if(v.position.z>0)then
							if(v.camps[1] and v.camps[1].x and v.camps[1].y)then
								local aura=v.combatmodule:ApplyAuraByClass(XPRACTICE.THEJAILER2.Aura_DeathGrip_GhostCheat)							
								aura.destination={x=v.camps[1].x,y=v.camps[1].y,z=0}
							end
						else
							v:SuggestRoll(math.random()*1.0)
						end
					end
				end
			end)

			self:NewEvent(1,10.5,function()
				-- bloodsoak 2
				for k,v in pairs(XPRACTICE.THEJAILER2.ChoreographyPhase1.soak2) do
					index=tonumber(string.sub(k,2))
					scenario.allpcs[index]:SetCamp(v[1],v[2],nil,math.random()*1.0)
				end
				self:EverybodyFaceBoss()
				
			end)						
			self:NewEvent(1,11,function() scenario.statuslabel:SetText("Soak now!  Afterwards, group B soaks tank knockback.",5.0) end)
			
			self:NewEvent(1,14.5,function()
				tank2:SetCamp(34.99,17.5)
				tank1:SetCamp(29.23,4.61)
				self:EverybodyFaceBoss()
				if(scenario.bloods and scenario.bloods[2])then
					scenario.bloods[2].fadestarttime=self.environment.localtime
					scenario.bloods[2].expirytime=self.environment.localtime+0.25
				end				
				if(scenario.bloods and scenario.bloods[3])then
					scenario.bloods[3].fadestarttime=self.environment.localtime
					scenario.bloods[3].expirytime=self.environment.localtime+0.25
				end				
				self:DealWithMartyrdom(2)
			end)
			
			
			self:NewEvent(1,17,function()
				-- martyrdom B	
				if(IAmGameHost(multiplayer))then
					spells.martyrdom:Broadcast_v2(scenario)					
				end	
			end)
			
			
			
			
			
			self:NewEvent(1,18.5,function()
				tank1:SuggestTauntBoss()
				tank1:SetCamp(25.51,-14.17)
				boss:SetCamp(27.34,-2.06)
				self:EverybodyFaceBoss()				
			end)
			
			self:NewEvent(1,19,function() scenario.statuslabel:SetText("Bomb runes soon.  Ranged rotate clockwise.",5.0) end)
			
			self:NewEvent(1,20.5,function()
				--melee follow boss
				tank2:SetCamp(30.85,3.02)
				self:SetMeleeCamp(23.64,1.46,5,0,1.0)				
				--ranged rotate CW
				for i=3,7 do
					local mob=scenario.roles[i].mob
					if(mob.position.y>-18)then
						if(mob.position.x<37)then
							self:SetCamp({mob},25.74,-22.60,7,0,0.5)
						else
							self:SetCamp({mob},44.80,-33.83,7,0,0.5)
						end
					end
				end
				for i=13,20 do
					local mob=scenario.roles[i].mob
					if(mob.position.y>-18)then
						if(mob.position.x<37)then
							self:SetCamp({mob},25.74,-22.60,7,0,0.5)
						else
							self:SetCamp({mob},44.80,-33.83,7,0,0.5)
						end
					end
				end				
				self:EverybodyFaceBoss()			
					
			end)
					
			
			self:NewEvent(1,24,function()
				tank1:SetCamp(36.33,-7.27)
				self:OnePlayerFaceBoss(tank1,boss)
			end)
			
			self:NewEvent(1,24,function()
				-- bombrunes 3
				XPRACTICE.THEJAILER2.ExplosiveRunesManager.nextcast=3
				if(IAmGameHost(multiplayer))then
					spells.explosiverunes:Broadcast_v2(scenario)
				end				
			end)	
			
			
			self:NewEvent(1,25,function() scenario.statuslabel:SetText("Spread out for targeted circles.\n(Move toward bloodsoak 3 positions if you're soaking.)",5.0) end)
			--maybe don't need CPUs to spread out for torment here?  just had bloodsoak->tankKB->bombrunes

			self:NewEvent(1,30,function()
				-- torment
				if(IAmGameHost(multiplayer))then
					spells.torment1:Broadcast_v2(scenario)
				end					
			end)			
			
			self:NewEvent(1,31,function()
				-- move to bloodsoak3 positions (bombrunes should be expiring by now)
				for k,v in pairs(XPRACTICE.THEJAILER2.ChoreographyPhase1.soak3pre) do
					index=tonumber(string.sub(k,2))
					scenario.allpcs[index]:SetCamp(v[1],v[2],nil,0)
				end		
				self:EverybodyFaceBoss()
			end)
			
			self:NewEvent(1,33,function() scenario.statuslabel:SetText("Move to bloodsoak 3 positions.\n(Mind the upcoming LOS.)",5.0) end)
			
			self:NewEvent(1,38,function()
				-- domination -> tyranny 2				
				if(IAmGameHost(multiplayer))then
					spells.relentlessdomination:Broadcast_v2(scenario)
				end							
				for i=1,20 do
					local v=scenario.roles[i].mob
					local index="_"..tostring(i)
					if(not XPRACTICE.THEJAILER2.ChoreographyPhase1.soak3pre[index])then
						v:SetCamp(14.08,-18.81,0,math.random()*1.0)						
					else
						v:SetCamp(XPRACTICE.THEJAILER2.ChoreographyPhase1.soak3pre[index][1],XPRACTICE.THEJAILER2.ChoreographyPhase1.soak3pre[index][2],nil,math.random()*1.0)
					end
				end
				-- as things are currently arranged, tank2 has to move early to taunt boss into position later								
				tank2:SetCamp(-16.89,-38.22,12.57)	
				tank2:SuggestRoll()				
				self:EverybodyFaceBoss()
			end)

				
			
			self:NewEvent(1,44,function() scenario.statuslabel:SetText("Soak now! -> lines -> group A soaks tank KB",5.0) end)
			
			self:NewEvent(1,44,function()
				for k,v in pairs(XPRACTICE.THEJAILER2.ChoreographyPhase1.soak3) do
					index=tonumber(string.sub(k,2))
					scenario.allpcs[index]:SetCamp(v[1],v[2],nil,0)
				end										
				--TODO: if player is melee, make sure they're not soaking before setting camp
				self:SetMeleeCamp(10.49,-29.94,5.0)
				boss:SetCamp(14.06,-32.88)
				
				self:EverybodyFaceBoss()

			end)
			
			self:NewEvent(1,45.5,function()
				-- bloodsoak 3
				local v=XPRACTICE.THEJAILER2.ChoreographyPhase1.soak3._1				
				scenario.allpcs[1]:SetCamp(v[1],v[2],nil,0)
				self:EverybodyFaceBoss()
				if(scenario.bloods and scenario.bloods[4])then
					scenario.bloods[4].fadestarttime=self.environment.localtime+3.0
					scenario.bloods[4].expirytime=self.environment.localtime+3.25
				end				
				if(scenario.bloods and scenario.bloods[5])then
					scenario.bloods[5].fadestarttime=self.environment.localtime+3.0
					scenario.bloods[5].expirytime=self.environment.localtime+3.25
				end						
			end)
			
			self:NewEvent(1,48,function() scenario.statuslabel:SetText("Bomb runes 4 soon.  Rotate clockwise if possible.",5.0) end)
			self:NewEvent(1,48,function()				
				-- martyrdom A	
				if(IAmGameHost(multiplayer))then
					spells.martyrdom:Broadcast_v2(scenario)					
				end										
				self:DealWithMartyrdom(3)				
				--TODO: martyrdom KB causes tyranny lines to move at the last moment.  double-check timing?
			end)
			self:NewEvent(1,50,function()
				tank2:SuggestTauntBoss()									
				boss:SetCamp(-5.98,-36.13)		
				---- melee need to spread out for torment in a moment
				--self:SetMeleeCamp(-2.41,-32.81,5.0,0,1.0) 
				--self:EverybodyFaceBoss()
			end)			
			

			self:NewEvent(1,52.5,function()
				--TODO: rdps change depending on soak swaps
				for i=1,#XPRACTICE.THEJAILER2.ChoreographyPhase1.torment[3] do
					local dest=XPRACTICE.THEJAILER2.ChoreographyPhase1.torment[3][i]
					if(dest[1] and dest[2])then
						self.scenario.allpcs[i]:SetCamp(dest[1],dest[2],nil,math.pow(math.random(),2))
						self.scenario.allpcs[i]:SuggestRoll(1.0+math.random()*1.0)
					end
				end
				self:EverybodyFaceBoss()
			end)
			
			self:NewEvent(1,53,function()
				-- bombrunes 4
				XPRACTICE.THEJAILER2.ExplosiveRunesManager.nextcast=4
				if(IAmGameHost(multiplayer))then
					spells.explosiverunes:Broadcast_v2(scenario)
				end						
			end)
			
			self:NewEvent(1,57,function() scenario.statuslabel:SetText("Spread out for torment circles.",5.0) end)
			

			self:NewEvent(2,02,function()
				-- Torment
				if(IAmGameHost(multiplayer))then
					spells.torment1:Broadcast_v2(scenario)
				end	
			end)
			
			self:NewEvent(2,02,function() scenario.statuslabel:SetText("Be ready to lockgate out of grip.  Bloodsoak 4 after.  (Not chaining to Azeroth.)",5.0) end)
			
			self:NewEvent(2,07,function()
				-- gripchains
				-- queue up portal use for CPUs
				if(IAmGameHost(multiplayer))then
					spells.chainsofoppression:Broadcast_v2(scenario)
				end
			 	ActionButton_ShowOverlayGlow(scenario.gateitembutton.displayobject.drawable)
				-- queue up portal use for CPUs
				local gate=scenario.cpulockgates[4]
				self:EverybodyLockGate(gate)
				for k,v in pairs(scenario.allpcs) do
					v.afterlockgatefunc=function()
						-- camp is expected to be nil at this point (gate causes stopai)
						-- face boss immediately, and again after we move back to gate
						v:SetTemporaryCamp(gate.partner.position.x,gate.partner.position.y,nil,0,1.0+math.random(1.5))
						schedule:OnePlayerFaceBoss(v,boss)
						v:SetCamp(gate.partner.position.x,gate.partner.position.y)	
						schedule:OnePlayerFaceBoss(v,boss)
					end
				end								
			end)
			

			
			self:NewEvent(2,10,function()
				-- move to bloodsoak4 positions?
				self:SetAllCamp(-31.80,-10.43,7.0,0,1.0)
				tank2:SetCamp(-39.18,-7.43)
				tank1:SetCamp(-39.16,-10.26,0.5)
				boss:SetCamp(-28.09,-14.51)
				self:EverybodyFaceBoss()
			end)		
			self:NewEvent(2,10,function() scenario.statuslabel:SetText("Caution: 6 stacks of Azerite Radiation incoming.",5.0) end)		
			
			self:NewEvent(2,15,function() scenario.statuslabel:SetText("Soak now!  Next, bomb runes #5.",5.0) end)
			self:NewEvent(2,15,function()				
				-- bloodsoak 4 (six stacks)			
				tank1:SetCamp(-43.08,-11.19)
				self:EverybodyFaceBoss()
				if(scenario.bloods and scenario.bloods[6])then
					scenario.bloods[6].fadestarttime=self.environment.localtime+3.0
					scenario.bloods[6].expirytime=self.environment.localtime+3.25
				end										
			end)	
			
			
			self:NewEvent(2,20,function()
				-- bombrunes 5
				XPRACTICE.THEJAILER2.ExplosiveRunesManager.nextcast=5
					-- reactions might need to be delayed a bit to allow bloodsoak4 to finish
				if(IAmGameHost(multiplayer))then
					spells.explosiverunes:Broadcast_v2(scenario)
				end					
			end)
			
			self:NewEvent(2,26,function() scenario.statuslabel:SetText("Group B soaks tank knockback.",5.0) end)
			self:NewEvent(2,26,function() 
				tank1:SetCamp(-30.64,-3.38)
				self:EverybodyFaceBoss()
			end)
			
			
			self:NewEvent(2,31,function()
				-- martyrdom B
				if(IAmGameHost(multiplayer))then
					spells.martyrdom:Broadcast_v2(scenario)					
				end									
				self:DealWithMartyrdom(4)
				tank1:SetCamp(-26.67,9.64,160.13)
			end)
			self:NewEvent(2,32.5,function()
				tank1:SuggestTauntBoss()
				boss:SetCamp(-27.43,-2.09)
			end)		
			-- boss stays where he is going into phase 2.  bomb6 players have to dash CW, everyone else prepositions for phase 2
					
			
			self:NewEvent(2,33,function() scenario.statuslabel:SetText("Bomb runes #6 soon.  You may want a speed boost here.\nIf you are not targeted, stay in the current pie slice.",5.0) end)
			
			self:NewEvent(2,35,function()
				--torment spread
				for i=1,#XPRACTICE.THEJAILER2.ChoreographyPhase1.torment[4] do
					local dest=XPRACTICE.THEJAILER2.ChoreographyPhase1.torment[4][i]
					if(dest[1] and dest[2])then
						self.scenario.allpcs[i]:SetCamp(dest[1],dest[2],nil,math.pow(math.random(),2))
						self.scenario.allpcs[i]:SuggestRoll(1.0+math.random()*1.0)
					end
				end
				self:EverybodyFaceBoss()
			end)			
			
			self:NewEvent(2,38,function()
				-- bombrunes 6
				XPRACTICE.THEJAILER2.ExplosiveRunesManager.nextcast=6
				if(IAmGameHost(multiplayer))then
					spells.explosiverunes:Broadcast_v2(scenario)
				end				
				for k,v in pairs(self.scenario.allpcs) do				
					local ghost=v
					local aura=ghost.combatmodule:ApplyAuraByClass(XPRACTICE.Aura_StampedingRoar,ghost.combatmodule,ghost.localtime)
				end				
			end)
			
			self:NewEvent(2,41,function() scenario.statuslabel:SetText("Spread out.  LOS immediately after circles resolve.",5.0) end)
			
			self:NewEvent(2,46,function()			
				-- torment 4
				if(IAmGameHost(multiplayer))then
					spells.torment1:Broadcast_v2(scenario)
				end						
			end)		
			
			self:NewEvent(2,48,function()
				-- domination -> tyranny 3
					-- careful with positioning, torment is still active
				if(IAmGameHost(multiplayer))then
					spells.relentlessdomination:Broadcast_v2(scenario)
				end	
				tank1:SetCamp(-59.58,-0.23)
			end)	
			
			
			self:NewEvent(2,50,function() scenario.statuslabel:SetText("Dodge lines and phase 2 begins.  Don't stand on the hatches.",5.0) end)
			self:NewEvent(2,50,function()
				self:EverybodyToNearestHidingPlace(XPRACTICE.THEJAILER2.ChoreographyPhase1.los[3],0,1.0)				
				tank1:SetCamp(-59.58,-0.23)
				boss:SetCamp(-47.46,0.16)
				self:EverybodyFaceBoss()			
			end)
			
			self:NewEvent(2,55,function()
				self:SetMeleeCamp(-44.80,9.27,7,0,1.0)
				self:EverybodyFaceBoss()			
			end)
			
			self:NewEvent(3,07,function()
				-- don't know exactly when hatches open, but it needs to be late enough that Tyranny orbs don't cause them to close immediately after
				scenario.layout.pylonmanager:ResetToPhase2()
				boss.combatmodule.targetmob=nil
				boss.combatmodule.autoattacking=false
			end)
			
			self:NewEvent(3,10,function() 
				scenario.statuslabel:SetText("That's the end of phase 1!\nNow practice until you can do it in your sleep...",5.0) 
				
			end)

			if(true)then return end --!!!!!!!!!!!!!!
			
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			
			self:NewEvent(3,07,function()
				-- unholy attunement
			end)

			self:NewEvent(3,10,function() scenario.statuslabel:SetText("Vrykul runes run to boss.  No speed boosts.",5.0) end)

			self:NewEvent(3,11,function()
				-- worldcracker1
			end)		
			
			self:NewEvent(3,15,function()
				-- vrykulrunes 1
			end)
			
			self:NewEvent(3,16,function() scenario.statuslabel:SetText("Spread circles with echo.  Leave some room.",5.0) end)
			
			self:NewEvent(3,21,function()
				-- torment
			end)		
			
			self:NewEvent(3,22,function() scenario.statuslabel:SetText("Blood soak team moves into position.",5.0) end)			
			
			self:NewEvent(3,23,function()
				-- shattering blast 1
			end)		
			self:NewEvent(3,25,function()
				tank2:SuggestTauntBoss()
			end)

			self:NewEvent(3,32,function()
				-- move to bloodsoak5 positions
			end)		
			
			self:NewEvent(3,37,function()
				-- bloodsoak 5
				-- AND shattering blast
			end)			
			self:NewEvent(3,38.5,function()
				tank1:SuggestTauntBoss()
			end)
			
			self:NewEvent(3,41,function()
				-- shattering blast
			end)
			
			self:NewEvent(3,40,function() scenario.statuslabel:SetText("Ranged group baits decimator.",5.0) end)
			
			self:NewEvent(3,43,function()
				-- bait decimator
			end)		
			
			self:NewEvent(3,45,function()
				-- decimator (reminder: no more knockback)
			end)	
			
			self:NewEvent(3,52,function()
				-- unholy attunement
			end)
			
			self:NewEvent(3,56,function()
				-- worldcracker2
			end)
			
			self:NewEvent(4,00,function() scenario.statuslabel:SetText("Vrykul runes run to boss.  No speed boosts.",5.0) end)
			
			self:NewEvent(4,05,function()
				-- vrykulrunes2
			end)		

			self:NewEvent(4,07,function()
				-- shatteringblast
			end)	
			self:NewEvent(4,09,function()
				tank2:SuggestTauntBoss()
			end)		
			
			-- (a bit of downtime here, provided vrykul2 is resolved quickly)
					-- bloodsoakers get slightly less time
			
			self:NewEvent(4,10,function() scenario.statuslabel:SetText("Blood soak team moves into position.",5.0) end)			
			
			self:NewEvent(4,19,function() scenario.statuslabel:SetText("Blood soak will combo into decimator.  Stay alert.",5.0) end)			
			
			self:NewEvent(4,20,function()
				-- move to bloodsoak6 positions
			end)								
				
			self:NewEvent(4,22,function()
				-- shatteringblast
			end)			
			
			self:NewEvent(4,23.5,function()
				tank1:SuggestTauntBoss()
			end)
			
			
			
			self:NewEvent(4,24,function()
				-- bloodsoak 6
			end)
			
			self:NewEvent(4,27.5,function()
				-- decimator (might not be baitable?)
					-- also, bloodsoak is happening.  maybe earlier bloodsoak?
			end)		
			
			self:NewEvent(4,34,function()
				-- unholy attunement
			end)		

			self:NewEvent(4,37,function()
				-- shattering blast
			end)				
			
			self:NewEvent(4,41,function()
				-- worldcracker3
			end)		

			self:NewEvent(4,48,function()
				-- shattering blast
			end)	
			self:NewEvent(4,50,function()
				tank2:SuggestTauntBoss()
			end)		
			
			self:NewEvent(4,50,function() scenario.statuslabel:SetText("Vrykul runes + echo circles + decimator combo.",5.0) end)	
			
			self:NewEvent(4,55,function()
				-- vrykulrunes3
			end)						
			
			self:NewEvent(4,59,function()
				-- torment 
				-- (bait decimator??)
			end)
			
			self:NewEvent(5,01,function()
				-- decimator
			end)		
			
			self:NewEvent(5,07,function() scenario.statuslabel:SetText("Blood soak team moves into position.",5.0) end)			
			
			self:NewEvent(5,10,function()
				-- shattering blast
			end)				
			self:NewEvent(5,11,function()
				tank1:SuggestTauntBoss()
			end)

			self:NewEvent(5,12,function()
				-- move to bloodsoak7 positions
			end)				
			
			self:NewEvent(5,17,function()
				-- bloodsoak7
			end)
			
			self:NewEvent(5,22,function()
				-- unholy attunement
			end)		
			
			self:NewEvent(5,26,function()
				-- worldcracker4
			end)
			
			self:NewEvent(5,26,function() scenario.statuslabel:SetText("Spread circles with echo.  Leave some room.",5.0) end)
			
			self:NewEvent(5,31,function()
				-- torment
			end)		
			
			self:NewEvent(5,36,function()
				-- shattering blast
			end)				
			self:NewEvent(5,38,function()
				tank2:SuggestTauntBoss()
			end)		
			
			self:NewEvent(5,37,function() scenario.statuslabel:SetText("Ranged group baits decimator.",5.0) end)
			
			self:NewEvent(5,40,function()
				-- bait decimator?
			end)						
			
			self:NewEvent(5,41,function() scenario.statuslabel:SetText("Blood soak team moves into position.",5.0) end)			
			
			self:NewEvent(5,42,function()
				-- decimator
			end)			
			
			self:NewEvent(5,46,function()
				-- move to bloodsoak8 positions
			end)			
			
			self:NewEvent(5,50,function()
				-- shattering blast
			end)		
			self:NewEvent(5,51,function()
				tank1:SuggestTauntBoss()
			end)
			
			self:NewEvent(5,51,function()
				-- bloodsoak8
			end)
			
			--self:NewEvent(5,56,function()
				-- (vrykulrunes4 was removed)
			--end)					

			self:NewEvent(6,04,function()
				-- unholy attunement
			end)		

			self:NewEvent(6,04.5,function() scenario.statuslabel:SetText("Start making your way over to phase 3 positions.  Don't stand on the hatches.",5.0) end)						

			---------------------------------------------------------------------------------------------------------
			
			-- looks like holes open a few seconds before P3 stun?
			-- if possible, move to decimator bait spot before P3 stun
			-- check whether our guild uses a different decimator bait spot

			self:NewEvent(6,14.5,function()
				-- phase 3 stun
			end)	
			
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------

			self:NewEvent(6,30,function()
				-- everyone moves to SW triangle
					-- (ranged bait next decimator southwest-ish)
				-- boss -20.54,-24.30
				-- rdps -34.72, -38.00
				-- mdps -27.07, -30.48    
				-- tight stack, 2-3yd spread
				-- currenttank can face boss away now, since decimator doesn't KB
				-- tank1 -14.90, -19.25
			end)				
			
			
			self:NewEvent(6,32.5,function() scenario.statuslabel:SetText("Ranged group baits decimator.  Falling Rubble is in effect.",5.0) end)	
			
			
			self:NewEvent(6,34.5,function()
				tank1:SuggestTauntBoss()
			end)				

			self:NewEvent(6,36,function()
				-- world shatterer
					-- this causes the falling rubble effect around azeroth btw
					-- blood spawns 	-63.79,-0.30      -31.90,-55.39        63.96,-0.18
			end)				
			
			self:NewEvent(6,42.5,function()
				-- decimator
					-- check that mdps camp isn't getting hit by flail line (is there a flail line?)
					-- ranged moves to -48.80, -3.97 (this hatch is closed btw)
						-- 6-ish yard spread, BUT bloodsoak9 is nearby, make sure we're not clipping it
						-- (temporary waypoint around -46.94, -27.48 to avoid open hatch)
							-- (this was more important when decimator was KB)
					-- tank1 to -57.87,-3.11
				-- boss is frozen for 4 sec after decimator finishes casting!  (= 7 sec total)				
					-- boss to -48.25, -9.19
						-- boss casts linkchains while moving
					-- mdps follows boss, not tank1
						-- we don't care who gets chained to tank1
						-- mdps ends up at same camp as ranged.
					
			end)
			
			self:NewEvent(6,43.5,function() scenario.statuslabel:SetText("Rotate clockwise.  Tank chains soon; major damage incoming.",5.0) end)
			
			self:NewEvent(6,48.5,function() scenario.statuslabel:SetText("Azeroth soak after chains break.",5.0) end)
			
			self:NewEvent(6,50.5,function()
				-- linkchains
				-- when cast ends, tank1 leaps to -13.59, -17.60  (this hatch is also closed)
					-- (major raidwide defensive cooldown)
					--TODO: die of embarrassment if a chain doesn't break (requires 30yds away)
				-- looks like boss immediately follows with azeroth soak, no autoattack, so reactiontime doesn't have to be 0
			end)					
			
			self:NewEvent(6,53.5,function() scenario.statuslabel:SetText("After azeroth attack finishes, move over to blood.  (Do not chain to azeroth.)",5.0) end)
			
			self:NewEvent(6,53.5,function()
				-- azeroth soak				
				-- <s>some players can move to bloodsoak9 positions now</s> not chaining to azeroth
			end)
			self:NewEvent(6,54.5,function()
				tank2:SuggestTauntBoss()
			end)		

			self:NewEvent(7,00,function()
				-- place lock gate from     -39.21, -8.35   to  -25.42, -44.71
				-- move to bloodsoak9 positions
			end)		
			
			self:NewEvent(7,03,function() scenario.statuslabel:SetText("When blood soak ends, ranged moves north to bait defile.",5.0) end)
			
			self:NewEvent(7,03,function()
				-- bloodsoak9
					-- don't chain to azeroth
			end)		
			
			self:NewEvent(7,06,function()
				-- bait defile1
					-- any range who are not already north of boss (from bloodsoak9) move to -42.74,-4.47
			end)				
			
			self:NewEvent(7,08,function() scenario.statuslabel:SetText("Lock gate as soon as cast begins, then adds spawn.",5.0) end)
			
			self:NewEvent(7,09.5,function()			
				-- defile1
					-- all players run to lockgate and queue it
			end)	
			

			
			self:NewEvent(7,12.5,function()					
				-- torment
					-- ten players in penta spots, currentank stand so boss follows reasonable close to middle of penta, rest safety northwest
					-- penta spots centered on lock gate
							-- our guild is treating them more like hex spots.  front L/R on back corners of front hex, back L/R on front corners of R/L hexes, back mid on line between back hexes
					-- tank2 to -14.94, -49.23
					-- tank1 to -35.33, -49.49 (will step into blood10)
					-- boss to -20.92, -41.92
					-- safe players at -32.98, -31.74, 5yd spread?
					
				-- as torment expires, move to bloodsoak10 positions (i.e. everyone under boss/adds, azeroth doesn't get healed here)
							--			ranged stays NW side of penta to bait next decimator
							-- tank1 to -30.70, -52.87 
							-- boss takes a tiny step SW to -21.92, -42.92
			end)			
			
			self:NewEvent(7,13,function() scenario.statuslabel:SetText("Timewarp + blood soak soon.  Caution: six stacks.  Prevent adds from casting.",5.0) end)
			
			self:NewEvent(7,16.5,function()					
				-- timewarp
			end)
			
			--self:NewEvent(7,20,function()
			self:NewEvent(7,18.5,function()
				-- (torment echo resolves, adds spawn.)
				-- bloodsoak10 <s>(LEAVE AT LEAST ONE TICK IN POOL)</s> only for extended P3
				-- tank2 to -30.23, -48.12			
				-- tank1 to -30.70, -52.87 
						-- then to -35.33, -49.49 after first soak tick
				-- boss is still attacking tank2
			end)					
			
			self:NewEvent(7,21.5,function() scenario.statuslabel:SetText("Ranged group moves northwest to bait decimator.",5.0) end)
			
			self:NewEvent(7,26.5,function()
				-- decimator
				-- ranged moves south to bait defile2
					-- range to -28.08, -61.23 3-4yd spread
					-- melee to -10.58, -47.99 (about max melee range after what would have been decimator KB)
					-- specific melee are now following tank2 instead of boss
				-- tank1 to -30.70, -52.87 (finish bloodsoak10)
			end)		
			
			self:NewEvent(7,26.5,function() scenario.statuslabel:SetText("Ranged group moves south to bait defile.  Phase 4 soon.",5.0) end)
				
			self:NewEvent(7,33.5,function()
				-- defile2
				-- boss is frozen for about 1 second after casting defile
				-- wind rush totem?			
			end)				
			
			-- (boss should be 15% by now.  our guild gets linkchains sometimes)

			-- jailer is frozen for about 8 seconds after he hits 15% health
			-- as soon as jailer can move again, everyone sprints over to old P4 starting location.  looks like lockgate still unavailable.

			self:NewEvent(7,58,function()
				tank1:SuggestTauntBoss()
			end)		
			
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------
			---------------------------------------------------------------------------------------------------------

			self:NewEvent(8,52.5,function()
				-- diverted life shield, timewarp
					--TODO: what's the duration on defile? (60 sec)
			end)				
			
			self:NewEvent(9,0.5,function()
				-- (jailer can move again)
			end)		
			
			self:NewEvent(8,58,function() scenario.statuslabel:SetText("Caution: debuffs soon.  Do not dispel.",5.0) end)
			
			self:NewEvent(9,03,function()
				-- death sentence
			end)				

			self:NewEvent(9,03,function() scenario.statuslabel:SetText("Bomb runes + meteor cleave combo.  All players without bombs soak the cleave.",5.0) end)
			
			self:NewEvent(9,06.5,function()
				-- bombrunes7
			end)						
			
			self:NewEvent(9,12,function()
				-- meteor cleave
			end)					
			
			self:NewEvent(9,17,function()
				-- decimator
			end)						

			self:NewEvent(9,26,function() scenario.statuslabel:SetText("Dispel in 5 seconds.  Both tanks catch.",5.0) end)

			self:NewEvent(9,31,function() scenario.statuslabel:SetText("Dispel now.",2.0) end)

			self:NewEvent(9,31,function()
				-- dispel
			end)		
			
			self:NewEvent(9,33,function() scenario.statuslabel:SetText("Bomb runes + meteor cleave combo.  All players without bombs soak the cleave.",5.0) end)

			self:NewEvent(9,35,function()
				-- bombrunes8
			end)			
			
			self:NewEvent(9,42,function()
				-- torment
			end)			

			self:NewEvent(9,48,function()
				-- decimator
			end)			

			self:NewEvent(10,00,function()
				-- mass dispel (cast ends)
			end)					
			
			self:NewEvent(10,06,function()
				-- torment
			end)							
			
			self:NewEvent(10,13,function()
				-- meteor cleave
			end)

			self:NewEvent(10,18,function()
				-- bombrunes9
			end)			
			
			self:NewEvent(10,20.139,function()
				-- encounter ends
			end)					
		end	
		
		
		function class:Step(elapsed)
			super.Step(self,elapsed)
			
			self.time=self.time+elapsed
			
			if(self.nexteventid)then
				local continue=false
				local safety=0
				repeat
					safety=safety+1
					continue=false
					local nextevent=self.events[self.nexteventid]
					if(nextevent)then
						if(nextevent.done)then
							continue=true
							self.nexteventid=self.nexteventid+1
						else
							if(nextevent.time<=self.time)then
								continue=true
								nextevent.done=true
								nextevent.func()							
							end
						end
					end
				until(continue==false or safety>100)
			end
		end
		
		
	end
end